libosmocodec 1.13.1.1-afb4 Osmocom codec library

Functions | Variables
ecu.c File Reference
`#include <string.h>`
`#include <errno.h>`
`#include <osmocom/codec/ecu.h>`
`#include <osmocom/core/talloc.h>`

## Functions
struct osmo_ecu_state * | osmo_ecu_init (void *ctx, enum osmo_ecu_codec codec)
| initialize an ECU instance for given codec. More...
void | osmo_ecu_destroy (struct osmo_ecu_state *st)
| destroy an ECU instance More...
int | osmo_ecu_frame_in (struct osmo_ecu_state *st, bool bfi, const uint8_t *frame, unsigned int frame_bytes)
| process a received frame a substitute/erroneous frame. More...
int | osmo_ecu_frame_out (struct osmo_ecu_state *st, uint8_t *frame_out)
| generate output data for a substitute/erroneous frame. More...
bool | osmo_ecu_is_dtx_pause (struct osmo_ecu_state *st)
| check if the current state of this ECU is a DTX pause. More...
int | osmo_ecu_register (const struct osmo_ecu_ops *ops, enum osmo_ecu_codec codec)
| register an ECU implementation for a given codec More...

## Variables
static const struct osmo_ecu_ops * | g_ecu_ops [_NUM_OSMO_ECU_CODECS]

## Function Documentation

## ◆ osmo_ecu_destroy()

void osmo_ecu_destroy | ( | struct osmo_ecu_state * | st | ) |

destroy an ECU instance

References ARRAY_SIZE, osmo_ecu_state::codec, osmo_ecu_ops::destroy, and g_ecu_ops.

## ◆ osmo_ecu_frame_in()

int osmo_ecu_frame_in | ( | struct osmo_ecu_state * | st,
|  | bool | bfi,
|  | const uint8_t * | frame,
|  | unsigned int | frame_bytes
| ) |  |

process a received frame a substitute/erroneous frame.

Parameters

  [in] | st | ECU state/instance on which to operate
  [in] | bfi | Bad Frame Indication
  [in] | frame | received codec frame to be processed
  [in] | frame_bytes | number of bytes available in frame

References ARRAY_SIZE, osmo_ecu_state::codec, osmo_ecu_ops::frame_in, and g_ecu_ops.

## ◆ osmo_ecu_frame_out()

int osmo_ecu_frame_out | ( | struct osmo_ecu_state * | st,
|  | uint8_t * | frame_out
| ) |  |

generate output data for a substitute/erroneous frame.

Parameters

  [in] | st | ECU state/instance on which to operate
  [out] | frame_out | buffer for generated output frame

Returns
  number of bytes written to frame_out; negative on error

References ARRAY_SIZE, osmo_ecu_state::codec, osmo_ecu_ops::frame_out, and g_ecu_ops.

## ◆ osmo_ecu_init()

struct osmo_ecu_state * osmo_ecu_init | ( | void * | ctx,
|  | enum osmo_ecu_codec | codec
| ) |  |

initialize an ECU instance for given codec.

Parameters

  [in] | ctx | talloc context from which to allocate
  [in] | codec | codec for which to initialize/create ECU

References ARRAY_SIZE, osmo_ecu_state::codec, g_ecu_ops, and osmo_ecu_ops::init.

## ◆ osmo_ecu_is_dtx_pause()

bool osmo_ecu_is_dtx_pause | ( | struct osmo_ecu_state * | st | ) |

check if the current state of this ECU is a DTX pause.

Parameters

  [in] | st | ECU state/instance on which to operate

Returns
  true if DTX pause, false otherwise

References ARRAY_SIZE, osmo_ecu_state::codec, g_ecu_ops, and osmo_ecu_ops::is_dtx_pause.

## ◆ osmo_ecu_register()

int osmo_ecu_register | ( | const struct osmo_ecu_ops * | ops,
|  | enum osmo_ecu_codec | codec
| ) |  |

register an ECU implementation for a given codec

References ARRAY_SIZE, osmo_ecu_state::codec, and g_ecu_ops.

Referenced by __attribute__().

## Variable Documentation

## ◆ g_ecu_ops

const struct osmo_ecu_ops* g_ecu_ops[_NUM_OSMO_ECU_CODECS]
| static

Referenced by osmo_ecu_destroy(), osmo_ecu_frame_in(), osmo_ecu_frame_out(), osmo_ecu_init(), osmo_ecu_is_dtx_pause(), and osmo_ecu_register().